import java.io.InputStream;
import java.io.FileInputStream;
import java.io.FileNotFoundException;

import java_cup.runtime.Symbol;

//import errorMsg.ErrorMsg;
//import straightparse.SLLex;
//import straightparse.SLParse_parse;

public class Test {
    public static final boolean do_debug_parse = false;
    public static final boolean my_debug_parse = true;

    public static void main(String[] args) {
	String filename = args[0];
	//errorMsg.ErrorMsg errorMsg = new errorMsg.ErrorMsg(filename);
	InputStream inp;
	try {
	    inp = new FileInputStream(filename);
	} catch (FileNotFoundException e) {
	    throw new Error("File not found: " + filename);
	}
      
      /* create a parsing object */
      SLParse_parse sl = new SLParse_parse(new SLLex(inp));

      try {
	java_cup.runtime.Symbol res;
        if (do_debug_parse)
          res = sl.debug_parse();
        else
          res = sl.parse();
	Prog ast = (Prog)res.value;
	PPVisProg pretty_print =  new PPVisProg();
	System.out.println("// The AST looks like this:\n" + pretty_print.visit(ast));
      } catch (Throwable e) {
	e.printStackTrace();
	throw new Error(e.toString());
      } finally {
	/* do close out here */
      }
  }
}
